
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Special_tripsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const special_trips = await db.special_trips.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
        trip_type: data.trip_type
        ||
        null
            ,
            
        destination: data.destination
        ||
        null
            ,
            
        start_datetime: data.start_datetime
        ||
        null
            ,
            
        end_datetime: data.end_datetime
        ||
        null
            ,
            
        package_notes: data.package_notes
        ||
        null
            ,
            
        separate_payment_required: data.separate_payment_required
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await special_trips.setCamp_session( data.camp_session || null, {
            transaction,
        });
        

        

        

        return special_trips;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const special_tripsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
                trip_type: item.trip_type
            ||
            null
            ,
            
                destination: item.destination
            ||
            null
            ,
            
                start_datetime: item.start_datetime
            ||
            null
            ,
            
                end_datetime: item.end_datetime
            ||
            null
            ,
            
                package_notes: item.package_notes
            ||
            null
            ,
            
                separate_payment_required: item.separate_payment_required
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const special_trips = await db.special_trips.bulkCreate(special_tripsData, { transaction });

        // For each item created, replace relation files
        

        return special_trips;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const special_trips = await db.special_trips.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        if (data.trip_type !== undefined) updatePayload.trip_type = data.trip_type;
        
        
        if (data.destination !== undefined) updatePayload.destination = data.destination;
        
        
        if (data.start_datetime !== undefined) updatePayload.start_datetime = data.start_datetime;
        
        
        if (data.end_datetime !== undefined) updatePayload.end_datetime = data.end_datetime;
        
        
        if (data.package_notes !== undefined) updatePayload.package_notes = data.package_notes;
        
        
        if (data.separate_payment_required !== undefined) updatePayload.separate_payment_required = data.separate_payment_required;
        
        
        updatePayload.updatedById = currentUser.id;

        await special_trips.update(updatePayload, {transaction});

        
        
        if (data.camp_session !== undefined) {
            await special_trips.setCamp_session(
              
              data.camp_session,
              
              { transaction }
            );
        }
        

        
        

        

        return special_trips;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const special_trips = await db.special_trips.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of special_trips) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of special_trips) {
                await record.destroy({transaction});
            }
        });


        return special_trips;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const special_trips = await db.special_trips.findByPk(id, options);

        await special_trips.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await special_trips.destroy({
            transaction
        });

        return special_trips;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const special_trips = await db.special_trips.findOne(
            { where },
            { transaction },
        );

        if (!special_trips) {
            return special_trips;
        }

        const output = special_trips.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.camp_session = await special_trips.getCamp_session({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.camp_sessions,
        as: 'camp_session',
        
        where: filter.camp_session ? {
          [Op.or]: [
            { id: { [Op.in]: filter.camp_session.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.camp_session.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'special_trips',
                        'name',
                        filter.name,
                    ),
                };
            }
            
            if (filter.destination) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'special_trips',
                        'destination',
                        filter.destination,
                    ),
                };
            }
            
            if (filter.package_notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'special_trips',
                        'package_notes',
                        filter.package_notes,
                    ),
                };
            }
            

            
            
            if (filter.calendarStart && filter.calendarEnd) {
                where = {
                    ...where,
                    [Op.or]: [
                        {
                            start_datetime: {
                                [Op.between]: [filter.calendarStart, filter.calendarEnd],
                            },
                    },
                {
                    end_datetime: {
                        [Op.between]: [filter.calendarStart, filter.calendarEnd],
                    },
                },
                ],
            };
            }
            

            
            if (filter.start_datetimeRange) {
                const [start, end] = filter.start_datetimeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    start_datetime: {
                    ...where.start_datetime,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    start_datetime: {
                    ...where.start_datetime,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.end_datetimeRange) {
                const [start, end] = filter.end_datetimeRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    end_datetime: {
                    ...where.end_datetime,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    end_datetime: {
                    ...where.end_datetime,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.trip_type) {
                where = {
                    ...where,
                trip_type: filter.trip_type,
            };
            }
            
            if (filter.separate_payment_required) {
                where = {
                    ...where,
                separate_payment_required: filter.separate_payment_required,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.special_trips.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'special_trips',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.special_trips.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

